# 苍穹许可API开发手册
**本页主要介绍许可的API方法，开发者可以调用这些接口达到添加删除用户许可分组等目的。**

**如果您有什么建议，欢迎在[金蝶社区](https://club.kdcloud.com/)留言反馈，我们会根据您的需求进行优化。**

## 1.调整用户许可分组的接口

### 1.1 添加用户至指定分组

调用代码：
```java
List<Long> userIds;
LicenseServiceHelper.addUserListByGroupId(2, userIds);
```

#### 参数说明：

参数|说明
---|---
Object groupId | 分组id
List\<Long> userIds | 待添加的人员集合


分组id可以在许可分配界面获取，在浏览器打开开发者工具，左树点击想要添加的分组，查看请求中的树节点id参数，如下图：
![logo](查询许可分组id.png '查询许可分组id')  

#### 返回值说明：
List\<Long> 添加成功的人员id集合

### 1.2 删除用户许可分组

调用代码：
```java
Set<Long> userID = new HashSet<>();
LicenseServiceHelper.deleteUserLicGroup(userID, true);
```

#### 参数说明：

参数|说明
---|---
Set\<Long> userID | 用户ID集合
Boolean deleteSyncGroup | 清除同步状态的分组 true:清除已同步;false:清除非已同步(包含未同步,同步异常);null:清除所有该用户许可分组

#### 返回值说明：无


## 2.同步用户许可分组的接口

### 2.1 同步增量许可用户

#### 接口说明：将增量表及非已同步状态用户进行整理同步，与同步许可用户界面“同步许可”功能相同

调用代码：
```java
Map<String, Object> result = LicenseServiceHelper.syncUserGroup();
```

#### 参数说明：无

#### 返回值说明：
Map<String, Object>

key|value
---|---
success|true/false
msg|失败信息

### 2.2 同步指定用户

调用代码：
```java
LicenseServiceHelper.syncUserGroup(userId);
Set<Long> userIds = new HashSet<>();
LicenseServiceHelper.syncUserGroup(userIds);
```

#### 参数说明：
参数|说明
---|---
Long userId | 用户ID
Set\<Long> userIds | 用户ID集合