# 参数接口

## 获取公共参数

```java
// 获取整体公共参数
Map<String,Object> publicParamWhole = SystemParamServiceHelper.loadPublicParametersFromCache();

// 获取某个公共参数值
String publicKey = "loginaccounttype"; // 登录账号类型
Object publicValue= SystemParamServiceHelper.loadPublicParameterFromCache(publicKey);
```


## 获取单据参数

```java
String formId = "test_form"; // 单据标识number
BillParam bp = SystemParamServiceHelper.loadBillParameterFromCache(formId);
```



﻿##  获取应用参数

```java
//参数属性字段key
String paramKey = "yzjurl"; 

//基础服务的APPID
String appId = "83bfebc8000037ac";
AppParam apm = new AppParam();
apm.setAppId(appId);
apm.setOrgId(Long.valueOf("100000")); // 参数的组织ID

//获取整体应用参数
Map<String,Object> paramWhole = SystemParamServiceHelper.loadAppParameterFromCache(apm);

//获取yzjurl的参数值
//从整个应用参数中获取某个参数属性值
Object paramValue = paramWhole.get(paramKey); 

//直接获取某个应用下的某个属性参数值
paramValue= SystemParamServiceHelper.loadAppParameterFromCache(apm,paramKey);
```



### 参数接口ParameterHelper

- 保存公共参数、云产品参数、应用参数

  ```java
  public static void SaveSysParameter(String parameterFormId, Long orgId, Long acctBookId, Long acctpolicyID, Long subSystem, String jsonData)
  ```

- 保存单据参数

  ```java
  public static void SaveBillParameter(String parameterFormId, String formId, String jsonData)
  ```

- 保存单据类型参数

  ```java
  public static void SaveBillTypeParameter(String parameterFormId, String formId, Long billTypeId, String jsonData)
  ```

- 保存用户参数

  ```java
  public static void SaveUserParameter(String parameterFormId, Long userId, Long orgId, String formId, String jsonData)
  ```

- 获取公共参数、云产品参数、应用参数接口

  ```java
  public static String GetSysParameter(Long orgId, Long acctBookId, Long acctpolicyID, Long subSystem)
  ```

- 获取单据参数

  ```java
  public static String GetBillParameter(String formId)
  ```

- 获取单据类型参数

  ```java
  public static String GetBillTypeParameter(String formId, Long billTypeId)
  ```

- 获取用户(组织)选项

  ```java
  public static String GetUserParameter(Long userId, Long orgId, String formId)
  ```