# 数据库操作服务帮助类

`kd.bos.servicehelper.DBServiceHelper`数据库操作服务帮助类为数据库操作上层封装，简化数据库操作。

举例，生成实体主键：

```java
String id = DBServiceHelper.genStringId();
```



## API 概览 

| 方法                                                      | 说明                     |
| --------------------------------------------------------- | ------------------------ |
| static long genGlobalLongId()                             | 生成全局唯一的长整形主键 |
| static long[] genLongIds(String tableName, int count)     | 批量生成长整型主键       |
| static String genStringId()                               | 生成字符型主键           |
| static String[] genStringIds(int count)                   | 批量生成字符型主键       |
| static String[] genStringIds(String tableName, int count) | 批量生成字符型主键       |



## API 详情

### 1、生成全局唯一的长整形主键

```java
static long genGlobalLongId()
```

传入参数：无

返回数据：全局唯一长整型



### 2、批量生成长整型主键

```java
static long[] genLongIds(String tableName, int count)
```

传入参数：

| 参数名称     | 参数      | 参数类型 | 是否必传 |
| ------------ | --------- | -------- | -------- |
| 物理表格名称 | tableName | String   | 是       |
| 生成主键个数 | count     | int      | 是       |

返回数据：

**批量生成的主键数组**，long[]



### 3、生成字符型主键

```java
static String genStringId()
```

传入参数：无

返回数据：字符型主键



### 4、批量生成字符型主键

```java
static String[] genStringIds(int count)
```

传入参数：

| 参数名称     | 参数  | 参数类型 | 是否必传 |
| ------------ | ----- | -------- | -------- |
| 生成主键个数 | count | int      | 是       |

返回数据：

**批量生成的主键数组**，String[]



### 5、批量生成字符型主键

```java
static String[] genStringIds(String tableName, int count)
```

传入参数：

| 参数名称     | 参数      | 参数类型 | 是否必传 |
| ------------ | --------- | -------- | -------- |
| 物理表格名称 | tableName | String   | 是       |
| 生成主键个数 | count     | int      | 是       |

返回数据：

**批量生成的主键数组**，String[]

