## 插件中获取某张单据的签名方案接口

```java
SignServiceHelper.getSignSCheme(String orgId, String formId)
```

#### 参数

`orgId`：单据主组织，签名方案开启组织受控时传入，如果没有或不需要受控则传null

`formId`：单据编码

返回类型 `SignScheme` 签名方案

```java
 String formNumber; //业务对象编码

 String formName; //业务对象名称

 String signField; //签名字段

 String signOperate; //签名操作

 String verifyOperate; //验签操作
```



## 插件中获取某张单据数据是否被篡改接口：



### 单张单据验签

```java
SignServiceHelper.verifySignById(String formId,Object id)
```

#### 参数

`formId`：单据编码

`id`：单据 `pkId`

#### 返回值

- `VerifySignInfo` 验签结果
  - `success` 验签是否成功
  - `message` 验签错误信息



### 批量验签

```java
SignServiceHelper.verifySignByIds(String formId,List<Object> ids)
```

#### 参数

`formId`：单据编码

`ids`：单据 `pkId` 的列表

#### 返回值

- `Map<Object,VerifySignInfo>` 验签结果
  - `key`为单据`pkId`
  - `value` 为 `VerifySignInfo` ，单据对应验签信息
    - `success` 验签是否成功
    - `message` 验签错误信息

