# 界面显示参数


## 接口FormShowParameter

### 方法说明

| 方法名称        | 说明                                       |
| --------------- | ------------------------------------------ |
| getCustomParams | 获取自定义参数                             |
| getParentFormId | 获取父表单内码                             |
| getAppId        | 获取页面所在应用编码                       |
| getFormId       | 获取动态表单内码                           |
| getOpenStyle    | 获取打开风格，通过打开风格可以设置页面样式 |
| setShowTitle    | 设置显示标题                               |

### 示例

```java
Long bookTypeId = this.getView().getFormShowParameter().getCustomParam(GLField.BOOKTYPE);

if (OperationStatus.ADDNEW.equals(this.getView().getFormShowParameter().getStatus())) {
	this.getView().setVisible(false, "relationtab");
}


String formId = this.getView().getFormShowParameter().getFormId();
//字符串排序，根据第一个大小排序，所以不能用十进制的数字字符串进行排序
DynamicObjectCollection collection = QueryServiceHelper.query(formId, selectFields, filters, "entryentity.balrowid asc");

```



## 接口BillShowParameter

### 方法说明

| 方法名称               | 说明                                       |
| ---------------------- | ------------------------------------------ |
| setEnableUserReentrant | 设置页面同一用户可以重复打开，不控制互斥锁 |
| isLayout               | 判断表单是不是布局类型                     |

### 示例

```java
BillShowParameter param = new BillShowParameter();
param.setFormId(EntityName.BILL_ACCRISKSET);
param.setCustomParam("abc",super.getAccountBook());
//设置打开方式 NewTabPage页签、Floating 浮动 、Modal 模态 ..
param.getOpenStyle().setShowType(ShowType.Modal);
//设置页面关闭回调
param.setCloseCallBack(new CloseCallBack(this, CALLBACK_KEY));
this.getView().showForm(param);
```