# 扩展的规范和要求

### 云和应用编码规范

{ISV标识}\_{云编码}
{ISV标识}\_{应用编码}

例如：
LT_MFG
LT_PRD  (生产任务应用)

### 设计器对象命名规范

#### 业务对象命名

{ISV标识}\_{业务对象标识}

- 整个系统中不允许重复
- 长度不超过36位
- 对象名为字符、_、数字
- 不能以数字开头

例如：
LT_PurchaseOrder

#### 元素命名
元素包括：控件、字段、容器、实体。

{ISV标识}\_{元素标识}

- 当前业务对象中不允许重复
- 长度不超过36位
- 对象名为字符、_、数字
- 不能以数字开头

#### 特殊要求
实体的表名属性、字段的字段名属性要求:

- 长度<=24位
- 表名：TK\_{ISV标识}\_{表名}
- 字段名：FK\_{ISV标识}\_{字段名}
- 不能以数字开头

### 继承体系

- 表单类插件
	- 表单、单据、基础资料、移动
	- 列表、报表
- 实体类插件 
    - 操作
    - 反写规则
    - 单据转换
- 插件命名规范
- 增加ISV前缀
- 插件继承关系
    - 表单类插件  - bos-form-core.jar

    - 实体类插件  - bos-entity-core.jar

<table><tr><td> 业务对象类型</td><td>应用场景</td><td>预置的Java插件基类</td></tr><tr><td rowspan="2">动态表单</td><td>PC端界面</td><td>AbstractFormPlugin</td></tr><tr><td>移动端界面</td><td>AbstractMobFormPlugin </td></tr><tr></tr><tr><td rowspan="10">单据、基础资料</td><td>PC端界面</td><td>AbstractBillPlugIn </td></tr><tr><td>移动端界面</td><td>AbstractMobBillPlugIn </td></tr><tr><td>单据列表</td><td>AbstractListPlugin</td></tr><tr><td>左树右表单据列表</td><td>AbstractTreeListPlugin</td></tr><tr><td>树形基础资料列表</td><td>StandardTreeListPlugin</td></tr><tr><td>移动端单据列表</td><td>AbstractMobListPlugin </td></tr><tr><td>业务操作</td><td>AbstractOperationServicePlugIn</td></tr><tr><td>单据转换</td><td>AbstractConvertPlugIn </td></tr><tr><td>关联反写</td><td>AbstractWriteBackPlugIn</td></tr><tr><td>生成凭证</td><td>AbstractBuildVchPlugin</td></tr></table>
