# 脚本规范

### 脚本命名规范

产品代号\_版本号\_云标识\_应用标识\_类型标识[\_功能标识][\_子功能标识].sql

类型标识：分table、view、constraint、data 四类；

示例：
- kd_3.0.2_bos_botp_table.sql
- kd_3.0_beta_bos_botp_table.sql
- kd_1.0_sp1_bos_meta_table.sql
- kd_1.0_sp2_bos_base_table_sysparam.sql

### PDM构建

![package](image\sql01.png)

![package](image\sql02.jpg)





### DataModel定义
```xml
<?xml version="1.0" encoding="utf-8"?>
<Package name="fi">
	<ver>1.0</ver>
	<app>
		<item id="ai" name="ai" path="main/ai"/>
		<item id="bcm" name="bcm" path="main/bcm"/>
		<item id="bd" name="bd" path="main/bd"/>
		<item id="cas" name="cas" path="main/cas"/>
		<item id="er" name="er" path="main/er"/>
		<item id="fa" name="fa" path="main/fa"/>
		<item id="gl" name="gl" path="main/gl"/>
		<item id="iep" name="iep" path="main/iep"/>
	</app>
</Package>
```

### 应用定义
```xml
<?xml version="1.0" encoding="utf-8"?>
<DataModel dympath="metadata">
	<SqlScript Type="KSQL" Separator=";" dbkey="fi">preinsdata/kd_0.1beta_gl_data.sql</SqlScript>
	<SqlScript Type="KSQL" Separator=";" dbkey="fi">dbschema/kd_0.2_gl_table.sql</SqlScript>
	<SqlScript Type="KSQL" Separator=";" dbkey="fi">preinsdata/kd_0.2_gl_data.sql</SqlScript>
	<SqlScript Type="KSQL" Separator=";" dbkey="fi">dbschema/kd_0.2_gl_constraint.sql</SqlScript>
</DataModel>
```

Ddl脚本： 通过工具生成，导出PDM差量，迁入到svn： /应用/dbschema目录下；

签入规则： pdm的文件名或包名必须与应用一致；