web单据api插件
==============

API概述
-------

为了满足更多的需求，API进行了一些调整，其主要改动地方有两点：  

- 对API原有列表增加按组织归类显示

- 对API增加了API授权操作

  
    按API授权
    按应用授权

API的使用
---------

API的使用一共有四个步骤：

**步骤一：注册应用**

进入【开发服务云】的【开放平台】应用中，右侧悬浮菜单栏打开【第三方应用】，新增需要使用的第三方应用

![](media/5422b861b71cc0c8f786832f9424ba66.png)

**步骤二：获取应用token**

[api访问地址前缀] /api/getAppToken.do [POST]

① 接口描述：允许第三方系统通过API得到应用Token。

② 功能说明：根据第三方appid和appSecuret返回后续API访问所需要的app_token。

③ HTTP请求方式：POST

④请求参数格式：JSON

⑤ 返回格式：JSON

⑥调用限制：无

⑦ 请求示例：

![](media/e3245a10b9fcb534e1b2e33285500fdc.png)

![](media/0854a8897a3177f63f75ddea1d3acb1e.png)

⑧参数说明：

传入参数：

![](media/d2f94e4b75652aada8027026ad36c8fd.png)

返回参数：

![](media/89613ea1b679f6c3d6cf121183b5b7e6.png)

**步骤三：登录API接口获取AccessToken**

[api访问地址前缀] /api/login.do [POST]

① 接口描述：允许第三方系统用户标识和标识类型登录到系统。

② 功能说明：根据用户标识和标识类登录到系统并返回后续API访问所需要的
access_tokent字符串。

③ HTTP请求方式：POST

④ 请求参数格式：JSON

⑤ 返回格式：JSON

⑥ 调用限制：无

⑦ 请求示例：

![](media/9801537034927cd914348d718fc204ff.png)

![](media/07f157b312f4423e6035508c7cb67cae.png)

参数说明

传入参数：

![](media/160567863c9a5dd83f43b97ddbe2911a.png)

返回参数：

![](media/dfee0fd737ec40d0e949a7d2800d6d02.png)

**步骤四：调用API接口**

在api调用的http header中添加参数accessToken进行调用

![](media/77ed8133fba79c910272277358ab1204.png)

API授权
-------

API授权分为按应用授权和用户授权两部分;

**按应用授权**

应用授权默认是不受限制可以访问的，只有将APP授权的“禁止访问”复选框设置成true后，该应用下的API将不允许被访问。

![](media/372d4a58f2cadd6e0dfc7e3eeea9d42f.png)

![](media/d1f6cb96650633b707d95b25787194c7.png)

**API用户授权**

默认状态下所有用户都有访问API的权限，当给某个API进行用户授权后，那么只有授权的用户才有访问权。

授权：点击API编码进入API的查看页，点击授权按钮进入API授权界面对API进行授权

![](media/43066e705dffa91315d970ce78da31a5.png)

![](media/97d965ebab6aab45c65e322a7f85ebf8.png)

**样例：AI服务**

**KS**

```

var plugin = new BillWebApiPlugin({ 
    doAICommand(e){
        var ret = e.getResult();
        ret.setSuccess(true);
        var data = {"aaa":"测试","bbb":"成功"};
        ret.setData(data);
        e.setResult(ret);
    }
});

```

![](media/bfe9d4fbaaeef01367425aaf71de95cb.png)

自定义服务:

![](media/0b1383df31a81f8c177667a49bb11c4d.png)

![](media/426b27e53ac90896737fc085272f6bbd.png)
