## 用途说明

获取当前请求上下文，其中包括登录租户，账套，用户等信息。



## 接口说明

- 获取当前上下文

  ```java
  public static RequestContext get()
  ```

- 获取当前租户账套信息

  ```java
  //获取租户ID
  public String getTenantId()
  //获取租户别名
  public String getTenantCode()
  //获取账套ID
  public String getAccountId()
  ```

- 获取当前用户信息

  ```java
  //获取用户UID
  public String getUid()
  //获取用户姓名
  public String getUserName()
  //获取用户类型
  public String getUserType()
  //获取用户登录的组织内码
  public long getOrgId()
  
  //第三方单点切换组织代码
  public String getLoginOrg()
  //云之家用户在IERP工作圈内ID
  public String getUserOpenId()
  ```

- 获取语言

  ```java
  //zh-CN、zh-TW、en-US
  public Lang getLang()
  ```

- 获取请求IP地址、请求时间

  ```java
  public String getLoginIP()
  public String getLoginTime()  
  ```

- 获取云之家登录信息

  ```java
  //获取云之家应用登录的AppId
  public String getYzjAppId()
  //获取云之家应用登录的Ticket
  public String getYzjAppTicket()
  ```

- 获取用户登录信息

  ```java
  //web web端登录 
  
  //mobile 手机端登录
  
  //api api形式登录
  
  //web service 登录
  
  public String getClient()
  ```

## 例子

```java
RequestContext rc = RequestContext.get();
Long orgId = rc.getOrgId();
//rc.getXXX();
//...
```

